using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using tine;
using NPlot;


namespace csBunchCurrentNPlot
{
  public partial class Form1 : Form
  {
    TDataType tdt;
    TDataType tnull;
    float[] currBuffer = new float[80];
    double[] dataX = new double[80];
    double[] dataY = new double[80];
    tine.TLink currLink;
    List<double> bunProfAxis = new List<double>();
    List<double> bunProfCurve = new List<double>();
    public Form1()
    {
      InitializeComponent();

    }
    public void updatePlot()
    {
      int i;
      bunProfCurve.Clear();
      for (i=0; i<79; i++)
      {
        dataY[i] = currBuffer[i];
        bunProfCurve.Add(dataY[i]);
      }
      bunchProfile.Refresh();
    }
    public void lcb(tine.TLink lnk)
    {
      if (lnk.GetStatus() != 0) Console.WriteLine("Link Status : " + lnk.GetStatus());
      if (bunchProfile.InvokeRequired)
        bunchProfile.Invoke(new MethodInvoker(updatePlot));
      else
        updatePlot();
    }
    TLink.TLinkCallback cb;

    private void Form1_Load(object sender, EventArgs e)
    {
      int i;

      // Add a background grid for better chart readability.
      Grid grid = new Grid();
      grid.VerticalGridType = Grid.GridType.Coarse;
      grid.HorizontalGridType = Grid.GridType.Coarse;
      grid.MajorGridPen = new Pen(Color.LightGray, 1.0F);

      bunchProfile.Add(grid);
      LinePlot bunProf = new LinePlot();
      bunProf.Pen = new Pen(Color.Green, 2);

      for (i = 0; i < 80; i++)
      {
        dataX[i] = i;
        bunProfAxis.Add(dataX[i]);
        bunProfCurve.Add(dataY[i]);
      }
      bunProf.AbscissaData = bunProfAxis;
      bunProf.DataSource = bunProfCurve;
      bunchProfile.Add(bunProf);
      //Balance plot general settings.
      bunchProfile.ShowCoordinates = true;
      bunchProfile.YAxis1.Label = "Bunch Profile";
      bunchProfile.YAxis1.LabelOffsetAbsolute = true;
      bunchProfile.YAxis1.WorldMax = 10;
      bunchProfile.YAxis1.WorldMin = 0;
      bunchProfile.YAxis1.LabelOffset = 40;
      bunchProfile.XAxis1.HideTickText = true;
      bunchProfile.Padding = 5;

      bunchProfile.Refresh();
    }

    private void button1_Click(object sender, EventArgs e)
    {
      int id;
      cb = new TLink.TLinkCallback(lcb);
      tdt = new TDataType(currBuffer);
      tnull = new TDataType(IntPtr.Zero);
      currLink = new TLink("/PETRA/BunchScope/Bunch-1", "I.Bunch.SCH", tdt, tnull, tine.Access.CA_READ);
      //id = currLink.Attach("/PETRA/BunchScope/Bunch-1", "BunchMarker.SCH", tdt, tnull, 1, 1000, cb, 2, 0, IntPtr.Zero);
      id = currLink.Attach(tine.Modes.CM_TIMER, cb, 1000);
    }

    private void button2_Click(object sender, EventArgs e)
    {
      currLink.Close();
    }
  }
}