Imports System.Runtime.InteropServices
Imports tine
Public Class Form1
  <StructLayout(LayoutKind.Sequential, Pack:=1, CharSet:=CharSet.Ansi)> _
  Public Structure SineInfo
    Public amplitude As Single
    Public frequency As Single
    Public noise As Single
    Public phase As Single
    Public numberCalls As Integer
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> _
      Public description() As Char
  End Structure
  Private Const PRP_SINE = 1
  Private Const PRP_AMPLITUDE = 2
  Private Const PRP_FREQUENCY = 3
  Private Const PRP_PHASE = 4
  Private Const PRP_NOISE = 5
  Private Const PRP_INFO = 6
  Private Const NUM_DEVICES = 10
  Private Const NUM_VALUES = (1024 * 8)
  Dim sinbuf(NUM_DEVICES - 1, NUM_VALUES - 1) As Single
  Dim tts As TTaggedStruct
  Dim sineInfoTable(NUM_DEVICES - 1) As SineInfo
  Dim myeqm As TEquipmentModule

  Public Function sineqm(ByVal dev As String, ByVal prp As String, ByVal dout As TDataType, ByVal din As TDataType, ByVal acc As UShort, ByVal eqm As TEquipmentModule) As Int32

    Dim fval As Single
    Dim mcarray(NUM_DEVICES) As Single
    Dim cc As Integer, i As Integer
    Dim devnr As Integer
    Dim prpid As Integer

    devnr = eqm.GetDeviceNumber(dev, prp)
    prpid = eqm.GetPropertyId(prp)
    'Select Case prp
    '  Case "Sine"
    '    cc = Errors.illegal_read_write
    '    If ((acc And Access.CA_WRITE) = 0) Then
    '      cc = dout.PutData(sinbuf, devnr, NUM_VALUES, 0)
    '      sineInfoTable(devnr).numberCalls = sineInfoTable(devnr).numberCalls + 1
    '    End If
    'End Select
    Select Case prpid
      Case PRP_SINE
        cc = Errors.illegal_read_write
        If ((acc And Access.CA_WRITE) = 0) Then
          cc = dout.PutData(sinbuf, devnr, NUM_VALUES, 0)
          sineInfoTable(devnr).numberCalls = sineInfoTable(devnr).numberCalls + 1
        End If
      Case PRP_AMPLITUDE
        If (din.GetDataArrayLength() > 0) Then
          If ((acc & Access.CA_WRITE) <> Access.CA_WRITE) Then
            cc = Errors.illegal_read_write
          End If
          cc = din.GetData(fval)
          If cc <> 0 Then Exit Select
          sineInfoTable(devnr).amplitude = fval
        End If
        If (dout.GetDataArrayLength() > 0) Then
          For i = 0 To NUM_DEVICES - 1
            mcarray(i) = sineInfoTable(i).amplitude
            cc = dout.PutData(mcarray, NUM_DEVICES, devnr)
            If cc <> 0 Then Exit Select
          Next
        End If
      Case PRP_FREQUENCY
        If (din.GetDataArrayLength() > 0) Then
          If ((acc & Access.CA_WRITE) <> Access.CA_WRITE) Then
            cc = Errors.illegal_read_write
          End If
          cc = din.GetData(fval)
          If cc <> 0 Then Exit Select
          sineInfoTable(devnr).frequency = fval
        End If
        If (dout.GetDataArrayLength() > 0) Then
          For i = 0 To NUM_DEVICES - 1
            mcarray(i) = sineInfoTable(i).frequency
            cc = dout.PutData(mcarray, NUM_DEVICES, devnr)
            If cc <> 0 Then Exit Select
          Next
        End If
      Case PRP_PHASE
        If (din.GetDataArrayLength() > 0) Then
          If ((acc & Access.CA_WRITE) <> Access.CA_WRITE) Then
            cc = Errors.illegal_read_write
          End If
          cc = din.GetData(fval)
          If cc <> 0 Then Exit Select
          sineInfoTable(devnr).phase = fval
        End If
        If (dout.GetDataArrayLength() > 0) Then
          For i = 0 To NUM_DEVICES - 1
            mcarray(i) = sineInfoTable(i).phase
            cc = dout.PutData(mcarray, NUM_DEVICES, devnr)
            If cc <> 0 Then Exit Select
          Next
        End If
      Case PRP_NOISE
        If (din.GetDataArrayLength() > 0) Then
          If ((acc & Access.CA_WRITE) <> Access.CA_WRITE) Then
            cc = Errors.illegal_read_write
          End If
          cc = din.GetData(fval)
          If cc <> 0 Then Exit Select
          sineInfoTable(devnr).noise = fval
        End If
        If (dout.GetDataArrayLength() > 0) Then
          For i = 0 To NUM_DEVICES - 1
            mcarray(i) = sineInfoTable(i).noise
            cc = dout.PutData(mcarray, NUM_DEVICES, devnr)
            If cc <> 0 Then Exit Select
          Next
        End If
      Case PRP_INFO
        If (din.GetDataArrayLength() > 0) Then
          If (din.GetDataFormat() <> Formats.CF_STRUCT) Then
            cc = Errors.illegal_format
            Exit Select
          End If
          If (din.GetDataTag().CompareTo("SineInfo") <> 0) Then
            cc = Errors.invalid_structure_tag
          End If
          Dim sinf As SineInfo
          sinf = New SineInfo()
          cc = din.GetData(sinf)
          If cc <> 0 Then Exit Select
          sineInfoTable(devnr).amplitude = sinf.amplitude
          sineInfoTable(devnr).frequency = sinf.frequency
          sineInfoTable(devnr).phase = sinf.phase
          sineInfoTable(devnr).noise = sinf.noise
        End If
        If (dout.GetDataArrayLength() > 0) Then
          If (dout.GetDataFormat() <> Formats.CF_STRUCT) Then
            cc = Errors.illegal_format
            Exit Select
          End If
          If (dout.GetDataTag() <> "SineInfo") Then
            cc = Errors.invalid_structure_tag
          End If
          If (dout.GetDataArrayLength() > NUM_DEVICES) Then dout.SetDataArrayLength(NUM_DEVICES)
          cc = dout.PutData(sineInfoTable, NUM_DEVICES, devnr)
        End If
      Case Else
        cc = Errors.illegal_property
    End Select
    sineqm = cc
  End Function
  Public Sub updateSine(ByVal devnr As Integer)
    Dim i As Integer, k As Integer
    Dim f As Single, n As Single, p As Single, a As Single
    f = sineInfoTable(devnr).frequency
    n = sineInfoTable(devnr).noise
    p = sineInfoTable(devnr).phase
    a = sineInfoTable(devnr).amplitude
    For i = 0 To NUM_VALUES - 1
      k = (i + p) Mod NUM_VALUES
      sinbuf(devnr, k) = (Rnd()) * n + (Math.Sin(f * i * 6.2832 / (NUM_VALUES / 8)) * a)
    Next
  End Sub
  Public Sub sinbkg()
    Dim i As Integer
    For i = 0 To NUM_DEVICES - 1
      Call updateSine(i)
    Next
  End Sub
  Public Sub sinini()
    Dim i As Integer, k As Integer
    Dim dsc As String
    For i = 0 To NUM_DEVICES - 1
      sineInfoTable(i).amplitude = 256
      sineInfoTable(i).frequency = 1
      sineInfoTable(i).phase = 0
      sineInfoTable(i).noise = 5.0
      ReDim sineInfoTable(i).description(63)
      dsc = "Sine device " + Str(i) + " at your service"
      For k = 0 To Len(dsc) - 1
        sineInfoTable(i).description(k) = dsc.Chars(k)
      Next
    Next
  End Sub
  Public Sub sinexi()
    Console.WriteLine("server stopping")
  End Sub
  Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    TKernel.InitializeServer()

    tts = New TTaggedStruct(sineInfoTable)

    myeqm = New TEquipmentModule("", "SINEQM", 0, AddressOf sineqm, AddressOf sinini, AddressOf sinbkg, 1000, AddressOf sinexi)

    TKernel.StartServices()

  End Sub
End Class
